//----------------------------------------------------------------------------------
// File:   ScreenSpaceAO.h
// Author: Miguel Sainz & Louis Bavoil
// Email:  sdkfeedback@nvidia.com
// 
// Copyright (c) 2008 NVIDIA Corporation. All rights reserved.
//
// TO  THE MAXIMUM  EXTENT PERMITTED  BY APPLICABLE  LAW, THIS SOFTWARE  IS PROVIDED
// *AS IS*  AND NVIDIA AND  ITS SUPPLIERS DISCLAIM  ALL WARRANTIES,  EITHER  EXPRESS
// OR IMPLIED, INCLUDING, BUT NOT LIMITED  TO, IMPLIED WARRANTIES OF MERCHANTABILITY
// AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT SHALL  NVIDIA OR ITS SUPPLIERS
// BE  LIABLE  FOR  ANY  SPECIAL,  INCIDENTAL,  INDIRECT,  OR  CONSEQUENTIAL DAMAGES
// WHATSOEVER (INCLUDING, WITHOUT LIMITATION,  DAMAGES FOR LOSS OF BUSINESS PROFITS,
// BUSINESS INTERRUPTION, LOSS OF BUSINESS INFORMATION, OR ANY OTHER PECUNIARY LOSS)
// ARISING OUT OF THE  USE OF OR INABILITY  TO USE THIS SOFTWARE, EVEN IF NVIDIA HAS
// BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
//
//
//----------------------------------------------------------------------------------

#define _CRT_SECURE_NO_DEPRECATE 1
//#define WIN32_LEAN_AND_MEAN

#pragma warning(disable:4995)

#include <DXUT.h>
#include <DXUTgui.h>
#include <DXUTmisc.h>
#include <DXUTCamera.h>
#include <DXUTSettingsDlg.h>
#include <SDKmisc.h>

// Global includes
#include "Scene3D.h"
#include "ScreenSpaceAOEngine.h"
#include "ScreenSpaceAOPaths.h"

// particular techniques
#include "RayMarchingAOEngine.h"
#include "HorizonBasedAOEngine.h"

// Other engines
#include "BilateralBlurEngine.h"
#include "ResolveEngine.h"

//--------------------------------------------------------------------------------------
// UI control IDs
//--------------------------------------------------------------------------------------
enum {
    IDC_TOGGLEFULLSCREEN = 1,
    IDC_TOGGLEREF,
    IDC_CHANGEDEVICE,
    IDC_CHANGETECHNIQUE ,
    IDC_CHANGEMESH,
    IDC_CHANGEMSAA,
    IDC_SHOW_DIFFUSE,
    IDC_SHOW_AO,
    IDC_USE_HALF_RES_AO,
};

#define MAX_PATH_STR                       512
#define MAX_SSAO_ENGINES                   2
