//----------------------------------------------------------------------------------
// File:   SimpleRT.h
// Author: Kevin Myers
// Email:  sdkfeedback@nvidia.com
// 
// Copyright (c) 2008 NVIDIA Corporation. All rights reserved.
//
// TO  THE MAXIMUM  EXTENT PERMITTED  BY APPLICABLE  LAW, THIS SOFTWARE  IS PROVIDED
// *AS IS*  AND NVIDIA AND  ITS SUPPLIERS DISCLAIM  ALL WARRANTIES,  EITHER  EXPRESS
// OR IMPLIED, INCLUDING, BUT NOT LIMITED  TO, IMPLIED WARRANTIES OF MERCHANTABILITY
// AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT SHALL  NVIDIA OR ITS SUPPLIERS
// BE  LIABLE  FOR  ANY  SPECIAL,  INCIDENTAL,  INDIRECT,  OR  CONSEQUENTIAL DAMAGES
// WHATSOEVER (INCLUDING, WITHOUT LIMITATION,  DAMAGES FOR LOSS OF BUSINESS PROFITS,
// BUSINESS INTERRUPTION, LOSS OF BUSINESS INFORMATION, OR ANY OTHER PECUNIARY LOSS)
// ARISING OUT OF THE  USE OF OR INABILITY  TO USE THIS SOFTWARE, EVEN IF NVIDIA HAS
// BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
//
//
//----------------------------------------------------------------------------------

#pragma once

class SimpleRT 
{
public:
    ID3D10Texture2D* pTexture;
    ID3D10RenderTargetView* pRTV;
    ID3D10ShaderResourceView* pSRV;

    SimpleRT( ID3D10Device* pd3dDevice, D3D10_TEXTURE2D_DESC* pTexDesc )
    {
        //These have to be set to have a render target
        pTexDesc->BindFlags = D3D10_BIND_RENDER_TARGET | D3D10_BIND_SHADER_RESOURCE;
        pTexDesc->Usage = D3D10_USAGE_DEFAULT;
        pTexDesc->CPUAccessFlags = NULL;

        pd3dDevice->CreateTexture2D( pTexDesc, NULL, &pTexture );
        pd3dDevice->CreateShaderResourceView( pTexture, NULL, &pSRV );
        pd3dDevice->CreateRenderTargetView( pTexture, NULL, &pRTV );
    }

    ~SimpleRT()
    {
        SAFE_RELEASE( pTexture );
        SAFE_RELEASE( pRTV );
        SAFE_RELEASE( pSRV );
    }
};